SystemOrganization addCategory: #'GMF-Generator'!
SystemOrganization addCategory: #'GMF-Generator-Tests'!

TestCase subclass: #ExampleGenerateCode
	instanceVariableNames: 'metamodel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator-Tests'!

!ExampleGenerateCode commentStamp: '<historical>' prior: 0!
This class show how we can use CodeGenerator and contains few example diagrams to generate. Some tests can be yellow but don't worry your classes are in package generatedClasses.

Step by step: 

1. Run test for prepare data
2. Run method to start generate code
3. Now go on step 1!

!ExampleGenerateCode methodsFor: 'initialize-release' stamp: 'volosmat 4/13/2014 14:07'!
setUp
	metamodel := MetaModel new.! !

!ExampleGenerateCode methodsFor: 'initialize-release' stamp: 'volosmat 4/24/2014 23:34'!
setUpBigModel
	| being person animal man woman child dog method phase object alien |
	metamodel := MetaModel new.
	being := Kind name: 'Being' metaModel: metamodel.
	Method name: 'isLive' returnDataType: 'boolean' element: being.
	
	object := Kind name: 'Bird' metaModel: metamodel.
	
	phase := Phase name: 'Death' metaModel: metamodel.
	ParentClass parentClass: being child: phase.
	ParentClass parentClass: object child: phase.
	
	phase := Phase name: 'Living' metaModel: metamodel.
	ParentClass parentClass: being child: phase.
	ParentClass parentClass: object child: phase.
	
	alien := SubKind name: 'Alien' metaModel: metamodel.
	ParentClass parentClass: being child: alien.
	
	person := SubKind name: 'Person' metaModel: metamodel.
	Attribute
				name: 'birthNumber'
				dataType: 'string'
				multiplicity: 1
				element: person.
	
	Attribute
				name: 'name'
				dataType: 'string'
				multiplicity: 1
				element: person.
	
	Attribute
				name: 'dateOfBirth'
				dataType: 'date'
				multiplicity: '0..1'
				element: person.
	
	Method name: 'age' returnDataType: 'integer' element: person.
	ParentClass parentClass: being complete: false disjoint: false child: person.
	animal := SubKind name: 'Animal' metaModel: metamodel.
	Method
				name: 'eat'
				returnDataType: 'boolean'
				abstract: true
				element: animal.
	
	
	Method
				name: 'sound'
				returnDataType: 'string'
				instance: false
				element: animal.
	ParentClass parentClass: being  complete: false disjoint: false  child: animal.
	
	FormalAssociation
				name: 'has'
				start: person
				startMultiplicity: 1
				end: animal
				endMultiplicity: '0..*'.
	
	man := Role name: 'Man' metaModel: metamodel.
	ParentClass parentClass: person child: man.
	woman := Role name: 'Woman' metaModel: metamodel.
	ParentClass parentClass: person child: woman. 
	child := Role name: 'Child' metaModel: metamodel.
	ParentClass parentClass: person child: child.
	"FormalAssociation
				name: 'wife'
				start: man
				startMultiplicity: 1
				end: woman
				endMultiplicity: 1.
	FormalAssociation
				name: 'husband'
				start: woman
				startMultiplicity: 1
				end: man
				endMultiplicity: 1.
	FormalAssociation
				name: 'mother'
				start: child
				startMultiplicity: '0..*'
				end: woman
				endMultiplicity: 1.
	FormalAssociation
				name: 'children'
				start: woman
				startMultiplicity: 1
				end: child
				endMultiplicity: '0..*'.
	FormalAssociation
				name: 'girlFriends'
				start: man
				startMultiplicity: '0..*'
				end: woman
				endMultiplicity: '0..*'.
	FormalAssociation
				name: 'boyFriends'
				start: woman
				startMultiplicity: '0..*'
				end: man
				endMultiplicity: '0..*'."
	
	dog := SubKind name: 'Dog' metaModel: metamodel.
	method := Method name: 'eat' returnDataType: 'boolean' element: dog.
	method parameters add: 'food'.
	method parameters add: 'testParam'.
	
	Method
				name: 'sound'
				returnDataType: 'string'
				instance: false
				element: dog.
	
	ParentClass parentClass: animal child: dog.
	
	! !

!ExampleGenerateCode methodsFor: 'initialize-release' stamp: 'volosmat 4/24/2014 19:52'!
setUpCategory
	| category category2 item item2 parent |
	
	category := Category name: 'TestCategory1' metaModel: metamodel.
	
	category addSubObject: ( Kind name: 'TestSubObject1' metaModel: metamodel ).
	category addSubObject: ( item := SubKind name: 'TestSubObject2' metaModel: metamodel).
	
	parent := Kind name: 'TestKind' metaModel: metamodel.
	ParentClass parentClass: parent child: item.
	
	category2 := Category name: 'TestCategory2' metaModel: metamodel.
	category2 addSubObject: ( item2 := SubKind name: 'TestItem2' metaModel: metamodel ).
	category2 addSubObject: item.
	ParentClass parentClass: parent child: item2.
! !

!ExampleGenerateCode methodsFor: 'initialize-release' stamp: 'volosmat 4/23/2014 21:20'!
setUpCollective
	| collective |
	
	collective := Collective name: 'Friends' metaModel: metamodel.
	
	
	MemberOf 	name: 				'person' 
				start:				(Kind name: 'Person' metaModel: metamodel)
				startMultiplicity: 	'1'
				end: 				collective
				endMultiplicity: 		'1..*'.
						
	MemberOf 	name: 				'animal' 
				start:				(Kind name: 'Animal' metaModel: metamodel)
				startMultiplicity: 	'1'
				end: 				collective
				endMultiplicity: 		'1..*'.
						
	MemberOf 	name: 				'gadget' 
				start:				(Kind name: 'Gadget' metaModel: metamodel)
				startMultiplicity: 	'1'
				end: 				collective
				endMultiplicity: 		'1..*'.				
	! !

!ExampleGenerateCode methodsFor: 'initialize-release' stamp: 'volosmat 4/27/2014 20:48'!
setUpEssential
	| brain person component heart |
	person 	:= Kind name: 'Person' metaModel: metamodel.
	brain    	:= Kind name: 'Brain' metaModel: metamodel.
	heart    := Kind name: 'Heart' metaModel: metamodel.
	
	component := ComponentOf 	name: 				'brain' 
									start:				brain
									startMultiplicity: 	'1'
									end: 				person
									endMultiplicity: 		'1'.
	component essential: true.
	
	component := ComponentOf 	name: 				'heart' 
									start:				heart
									startMultiplicity: 	'1'
									end: 				person
									endMultiplicity: 		'1'.
	component essential: true.! !

!ExampleGenerateCode methodsFor: 'initialize-release' stamp: 'volosmat 4/24/2014 22:56'!
setUpInseparable
	| brain person component |
	person 	:= Kind name: 'Person' metaModel: metamodel.
	brain    	:= Kind name: 'Brain' metaModel: metamodel.
	
	component := ComponentOf 	name: 				'brain' 
									start:				brain
									startMultiplicity: 	'1'
									end: 				person
									endMultiplicity: 		'1'.
	component inseparable: true
	! !

!ExampleGenerateCode methodsFor: 'initialize-release' stamp: 'volosmat 4/24/2014 22:41'!
setUpQuantity
	| mineralWater minerals quantity |
	
	mineralWater 	:= Quantity name: 'MineralWater' metaModel: metamodel.
	minerals 		:= Quantity name: 'Minerals' metaModel: metamodel.
	
	quantity := SubQuantityOf 	name: 				'quantity' 
								start: 				minerals 
								startMultiplicity: 	'1' 
								end: 				mineralWater 
								endMultiplicity: 		'1'.
	quantity essential: true.
! !

!ExampleGenerateCode methodsFor: 'initialize-release' stamp: 'volosmat 4/13/2014 21:22'!
setUpRelator
	| relator husband wife person man woman material1 material2 |
	relator := Relator name: 'Wedding' metaModel: metamodel.
	person := Kind name: 'Person' metaModel: metamodel.
	wife := Role name: 'Wife' metaModel: metamodel.
	woman := SubKind name: 'Woman' metaModel: metamodel.
	man := SubKind name: 'Man' metaModel: metamodel.
	husband := Role name: 'Husband' metaModel: metamodel.
	ParentClass parentClass: person child: woman.
	ParentClass parentClass: person child: man.
	ParentClass parentClass: woman child: wife.
	ParentClass parentClass: man child: husband.
	
	material1 := MaterialAssociation 	name: 				'husbandOf' 
										start: 				husband  
										startMultiplicity: 	'1..*'  
										end: 				wife 
										endMultiplicity: 		'1..*'.
	material2 := MaterialAssociation 	name: 				'marriedTo' 
										start: 				wife  
										startMultiplicity: 	'1..*'  
										end: 				husband 
										endMultiplicity: 		'1..*'.
												
	Derivation 				name: 				'husbandOf' 
							start: 				relator  
							startMultiplicity: 	'1'  
							end: 				material1 
							endMultiplicity: 		'1'.
	Derivation 				name: 				'marriedTo' 
							start: 				relator  
							startMultiplicity: 	'1'  
							end: 				material2 
							endMultiplicity: 		'1'.
	Mediation			 	name: 				'husband' 
							start: 				husband  
							startMultiplicity: 	'1..*'  
							end: 				relator 
							endMultiplicity: 		'1'.
	Mediation			 	name: 				'wife' 
							start: 				wife  
							startMultiplicity: 	'1..*'  
							end: 				relator 
							endMultiplicity: 		'1'.
	! !

!ExampleGenerateCode methodsFor: 'running' stamp: 'volosmat 4/24/2014 23:33'!
testPrepareBigModel
	self setUpBigModel.
	TransformToUML metaModel: metamodel.
	
	! !

!ExampleGenerateCode methodsFor: 'running' stamp: 'volosmat 4/24/2014 23:31'!
testPrepareCategory
	self setUpCategory.
	TransformToUML metaModel: metamodel.
	
	! !

!ExampleGenerateCode methodsFor: 'running' stamp: 'volosmat 4/24/2014 23:31'!
testPrepareCollective
	self setUpCollective.
	TransformToUML metaModel: metamodel.
	
	
! !

!ExampleGenerateCode methodsFor: 'running' stamp: 'volosmat 4/24/2014 23:31'!
testPrepareEssential
	self setUpEssential.
	TransformToUML metaModel: metamodel.
	
	
! !

!ExampleGenerateCode methodsFor: 'running' stamp: 'volosmat 4/24/2014 23:31'!
testPrepareInseparable
	self setUpInseparable.
	TransformToUML metaModel: metamodel.
	
	
! !

!ExampleGenerateCode methodsFor: 'running' stamp: 'volosmat 4/24/2014 23:32'!
testPrepareQuantity
	self setUpQuantity.
	TransformToUML metaModel: metamodel.
	
	
! !

!ExampleGenerateCode methodsFor: 'running' stamp: 'volosmat 4/24/2014 23:32'!
testPrepareRelator
	self setUpRelator.
	TransformToUML metaModel: metamodel.
	
	! !

!ExampleGenerateCode methodsFor: 'generate code' stamp: 'volosmat 4/24/2014 23:30'!
testRunGenerator
	"This method only initialize and run code generator."
	CodeGenerator clearPackage: 'generatedClasses'.
	CodeGenerator setDataWithAll: (DataForGenerator UMLElements: TransformToUML transformedElements).
	
	! !

TestCase subclass: #GenerateBigModel
	instanceVariableNames: 'metamodel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator-Tests'!

!GenerateBigModel methodsFor: 'initialize-release' stamp: 'volosmat 4/27/2014 14:45'!
setUp
	self
		setUpDB;
		setUpRoles;
		setUpRolesParent;
		setUpCollectives;
		setUpProjectTeam;
		setUpManagementDocuments;
		setUpRelators;
		setUpOtherKinds;
		setUpMediation! !

!GenerateBigModel methodsFor: 'initialize-release' stamp: 'volosmat 4/27/2014 15:16'!
setUpCollectives
	Collective name: 'ProjectTeam' metaModel: metamodel.
	Collective name: 'Organization' metaModel: metamodel.
	Collective name: 'SeniorManagement' metaModel: metamodel.
	Collective name: 'ManagementDocuments' metaModel: metamodel.
	
	SubCollectionOf
		name: 				'subCollProjectTeam'
		start: 				(metamodel at: 'ProjectTeam')
		startMultiplicity: 	'1'
		end: 				(metamodel at: 'Organization')
		endMultiplicity: 		'1..*'.
	SubCollectionOf
		name: 				'subCollSeniorManagement'
		start: 				(metamodel at: 'SeniorManagement')
		startMultiplicity: 	'1'
		end: 				(metamodel at: 'Organization')
		endMultiplicity: 		'1..*'.! !

!GenerateBigModel methodsFor: 'initialize-release' stamp: 'volosmat 4/27/2014 13:37'!
setUpDB
	metamodel := MetaModel new.
! !

!GenerateBigModel methodsFor: 'initialize-release' stamp: 'volosmat 4/27/2014 15:18'!
setUpManagementDocuments
	Kind name: 'RiskAssessment' metaModel: metamodel.
	Kind name: 'ProjectScope' metaModel: metamodel.
	Kind name: 'ProjectEstimate' metaModel: metamodel.
	Kind name: 'MasterTestPlan' metaModel: metamodel.
	Kind name: 'ProjectSchedule' metaModel: metamodel.
	Kind name: 'InitialRequirements' metaModel: metamodel.
	Kind name: 'Feasibility' metaModel: metamodel.
	Relator name: 'ProjectCharter' metaModel: metamodel.
	SubKind name: 'Technical' metaModel: metamodel.
	SubKind name: 'Operational' metaModel: metamodel.
	SubKind name: 'Economical' metaModel: metamodel.
	ParentClass 
		parentClass: 	(metamodel at: 'Feasibility') 
		child: 			(metamodel at: 'Technical').
	ParentClass 
		parentClass: 	(metamodel at: 'Feasibility') 
		child: 			(metamodel at: 'Operational').
	ParentClass 
		parentClass: 	(metamodel at: 'Feasibility') 
		child: 			(metamodel at: 'Economical').
	
	MemberOf
		name: 				'memberRiskAssessment'
		start: 				(metamodel at: 'RiskAssessment')
		startMultiplicity: 	'1'
		end: 				(metamodel at: 'ManagementDocuments')
		endMultiplicity: 		'1..*'.
	MemberOf
		name: 				'memberProjectScope'
		start: 				(metamodel at: 'ProjectScope')
		startMultiplicity: 	'1'
		end: 				(metamodel at: 'ManagementDocuments')
		endMultiplicity: 		'1..*'.
	MemberOf
		name: 				'memberProjectEstimate'
		start: 				(metamodel at: 'ProjectEstimate')
		startMultiplicity: 	'1'
		end: 				(metamodel at: 'ManagementDocuments')
		endMultiplicity: 		'1..*'.
	MemberOf
		name: 				'memberMasterTestPlan'
		start: 				(metamodel at: 'MasterTestPlan')
		startMultiplicity: 	'1'
		end: 				(metamodel at: 'ManagementDocuments')
		endMultiplicity: 		'1..*'.
	MemberOf
		name: 				'memberProjectSchedule'
		start: 				(metamodel at: 'ProjectSchedule')
		startMultiplicity: 	'1'
		end: 				(metamodel at: 'ManagementDocuments')
		endMultiplicity: 		'1..*'.
	MemberOf
		name: 				'memberProjectCharter'
		start: 				(metamodel at: 'ProjectCharter')
		startMultiplicity: 	'1'
		end: 				(metamodel at: 'ManagementDocuments')
		endMultiplicity: 		'1..*'.
	MemberOf
		name: 				'memberFeasibility'
		start: 				(metamodel at: 'Feasibility')
		startMultiplicity: 	'1'
		end: 				(metamodel at: 'ManagementDocuments')
		endMultiplicity: 		'1..*'.
	MemberOf
		name: 				'memberInitialRequirements'
		start: 				(metamodel at: 'InitialRequirements')
		startMultiplicity: 	'1'
		end: 				(metamodel at: 'ManagementDocuments')
		endMultiplicity: 		'1..*'.! !

!GenerateBigModel methodsFor: 'initialize-release' stamp: 'volosmat 4/27/2014 20:44'!
setUpMediation
	Mediation 
		name: 				'documentation' 
		start: 				(metamodel at: 'CreateDocumentation') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'Documentation') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'technicalWriter' 
		start: 				(metamodel at: 'CreateDocumentation') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'TechnicalWriter') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'tools' 
		start: 				(metamodel at: 'SelectTools') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'Tools') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'toolsSpecialist' 
		start: 				(metamodel at: 'SelectTools') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'ToolsSpecialist') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'groupMemory' 
		start: 				(metamodel at: 'CreateGroupMemory') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'GroupMemory') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'subjectMatterExpert' 
		start: 				(metamodel at: 'CreateGroupMemory') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'SubjectMatterExpert') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'tailorSoftwareProcess' 
		start: 				(metamodel at: 'TailorSoftwareProcess') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'SoftwareProcess') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'processSpecialist' 
		start: 				(metamodel at: 'TailorSoftwareProcess') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'ProcessSpecialist') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'artefacts' 
		start: 				(metamodel at: 'IdentifyArtefacts') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'Artefacts') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'infrastructureEngineer' 
		start: 				(metamodel at: 'IdentifyArtefacts') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'InfrastructureEngineer') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'riskAssessor' 
		start: 				(metamodel at: 'IdentifyRisks') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'RiskAssessor') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'riskAssessment' 
		start: 				(metamodel at: 'IdentifyRisks') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'RiskAssessment') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'plannerRequirements' 
		start: 				(metamodel at: 'AnalyzeRequirements') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'Planner') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'projectScope' 
		start: 				(metamodel at: 'AnalyzeRequirements') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'ProjectScope') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'plannerProject' 
		start: 				(metamodel at: 'AnalyzeWholeProject') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'Planner') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'projectEstimate' 
		start: 				(metamodel at: 'AnalyzeWholeProject') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'ProjectEstimate') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'masterTestPlan' 
		start: 				(metamodel at: 'AnalyzeWholeProject') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'MasterTestPlan') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'projectSchedule' 
		start: 				(metamodel at: 'AnalyzeWholeProject') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'ProjectSchedule') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'economicalAnalyst' 
		start: 				(metamodel at: 'DefineInitialRequirements') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'EconomicalAnalyst') 
		endMultiplicity: 		'1..*'.	
	Mediation 
		name: 				'initialRequirements' 
		start: 				(metamodel at: 'DefineInitialRequirements') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'InitialRequirements') 
		endMultiplicity: 		'1..*'.	
	Mediation 
		name: 				'teamTechnicalStudy' 
		start: 				(metamodel at: 'PerformTechnicalStudy') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'ProjectTeam') 
		endMultiplicity: 		'1..*'.	
	Mediation 
		name: 				'teamOperationalStudy' 
		start: 				(metamodel at: 'PerformOperationalStudy') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'ProjectTeam') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'teamEconomicalStudy' 
		start: 				(metamodel at: 'PerformEconomicalStudy') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'ProjectTeam') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'technical' 
		start: 				(metamodel at: 'PerformTechnicalStudy') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'Technical') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'operational' 
		start: 				(metamodel at: 'PerformOperationalStudy') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'Operational') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'economical' 
		start: 				(metamodel at: 'PerformEconomicalStudy') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'Economical') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'meetingFacilitator' 
		start: 				(metamodel at: 'KickOffMeeting') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'MeetingFacilitator') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'meetingProjectTeam' 
		start: 				(metamodel at: 'KickOffMeeting') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'ProjectTeam') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'qualityAssuranceEngineer' 
		start: 				(metamodel at: 'CheckStandards') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'QualityAssuranceEngineer') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'seniorManagementStandards' 
		start: 				(metamodel at: 'CheckStandards') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'SeniorManagement') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'seniorManagementCharter' 
		start: 				(metamodel at: 'ProjectCharter') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'SeniorManagement') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'projectManager' 
		start: 				(metamodel at: 'ProjectCharter') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'ProjectManager') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'projectSponsor' 
		start: 				(metamodel at: 'Budget') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'ProjectSponsor') 
		endMultiplicity: 		'1..*'.
	Mediation 
		name: 				'seniorManagementBudget' 
		start: 				(metamodel at: 'Budget') 
		startMultiplicity: 	'1'  
		end: 				(metamodel at: 'SeniorManagement') 
		endMultiplicity: 		'1..*'.! !

!GenerateBigModel methodsFor: 'initialize-release' stamp: 'volosmat 4/27/2014 14:49'!
setUpOtherKinds
	Kind name: 'Documentation' metaModel: metamodel.
	Kind name: 'GroupMemory' metaModel: metamodel.
	Kind name: 'Tools' metaModel: metamodel.
	Kind name: 'ProjectProcess' metaModel: metamodel.
	SubKind name: 'SoftwareProcess' metaModel: metamodel.
	Kind name: 'Artefacts' metaModel: metamodel.
	
	ParentClass 
		parentClass: 	(metamodel at: 'ProjectProcess')
		child: 			(metamodel at: 'SoftwareProcess')! !

!GenerateBigModel methodsFor: 'initialize-release' stamp: 'volosmat 4/27/2014 15:20'!
setUpProjectTeam

	MemberOf
		name: 				'memberPlanner'
		start: 				(metamodel at: 'Planner')
		startMultiplicity: 	'1'
		end: 				(metamodel at: 'ProjectTeam')
		endMultiplicity: 		'1..*'.
	MemberOf
		name: 				'memberRiskAssessor'
		start: 				(metamodel at: 'RiskAssessor')
		startMultiplicity: 	'1'
		end: 				(metamodel at: 'ProjectTeam')
		endMultiplicity: 		'1..*'.
	MemberOf
		name: 				'memberEconomicalAnalyst'
		start: 				(metamodel at: 'EconomicalAnalyst')
		startMultiplicity: 	'1'
		end: 				(metamodel at: 'ProjectTeam')
		endMultiplicity: 		'1..*'.
	MemberOf
		name: 				'memberInfrastructureEngineer'
		start: 				(metamodel at: 'InfrastructureEngineer')
		startMultiplicity: 	'1'
		end: 				(metamodel at: 'ProjectTeam')
		endMultiplicity: 		'1..*'.
	MemberOf
		name: 				'memberProcessSpecialist'
		start: 				(metamodel at: 'ProcessSpecialist')
		startMultiplicity: 	'1'
		end: 				(metamodel at: 'ProjectTeam')
		endMultiplicity: 		'1..*'.
	MemberOf
		name: 				'memberToolsSpecialist'
		start: 				(metamodel at: 'ToolsSpecialist')
		startMultiplicity: 	'1'
		end: 				(metamodel at: 'ProjectTeam')
		endMultiplicity: 		'1..*'.
	MemberOf
		name: 				'memberSubjectMatterExpert'
		start: 				(metamodel at: 'SubjectMatterExpert')
		startMultiplicity: 	'1'
		end: 				(metamodel at: 'ProjectTeam')
		endMultiplicity: 		'1..*'.
	MemberOf
		name: 				'memberTechnicalWriter'
		start: 				(metamodel at: 'TechnicalWriter')
		startMultiplicity: 	'1'
		end: 				(metamodel at: 'ProjectTeam')
		endMultiplicity: 		'1..*'.
	MemberOf
		name: 				'memberMeetingFacilitator'
		start: 				(metamodel at: 'MeetingFacilitator')
		startMultiplicity: 	'1'
		end: 				(metamodel at: 'ProjectTeam')
		endMultiplicity: 		'1..*'.
	MemberOf
		name: 				'memberProjectManager'
		start: 				(metamodel at: 'ProjectManager')
		startMultiplicity: 	'1'
		end: 				(metamodel at: 'ProjectTeam')
		endMultiplicity: 		'1..*'.
	MemberOf
		name: 				'memberProjectSponsor'
		start: 				(metamodel at: 'ProjectSponsor')
		startMultiplicity: 	'1'
		end: 				(metamodel at: 'ProjectTeam')
		endMultiplicity: 		'1..*'.
	MemberOf
		name: 				'memberQualityAssuranceEngineer'
		start: 				(metamodel at: 'QualityAssuranceEngineer')
		startMultiplicity: 	'1'
		end: 				(metamodel at: 'ProjectTeam')
		endMultiplicity: 		'1..*'.! !

!GenerateBigModel methodsFor: 'initialize-release' stamp: 'volosmat 4/27/2014 14:40'!
setUpRelators
	"relator project charter is in setUpManagementDocuments"
	Relator name: 'IdentifyRisks' metaModel: metamodel.
	Relator name: 'AnalyzeRequirements' metaModel: metamodel.
	Relator name: 'AnalyzeWholeProject' metaModel: metamodel.
	Relator name: 'DefineInitialRequirements' metaModel: metamodel.
	Relator name: 'PerformTechnicalStudy' metaModel: metamodel.
	Relator name: 'PerformOperationalStudy' metaModel: metamodel. 
	Relator name: 'PerformEconomicalStudy' metaModel: metamodel.
	Relator name: 'CheckStandards' metaModel: metamodel.
	Relator name: 'Budget' metaModel: metamodel.
	Relator name: 'KickOffMeeting' metaModel: metamodel.
	Relator name: 'CreateDocumentation' metaModel: metamodel.
	Relator name: 'CreateGroupMemory' metaModel: metamodel.
	Relator name: 'SelectTools' metaModel: metamodel.
	Relator name: 'TailorSoftwareProcess' metaModel: metamodel.
	Relator name: 'IdentifyArtefacts' metaModel: metamodel.! !

!GenerateBigModel methodsFor: 'initialize-release' stamp: 'volosmat 4/27/2014 13:36'!
setUpRoles
	Role name: 'ProjectManager' metaModel: metamodel.
	Role name: 'InfrastructureEngineer' metaModel: metamodel. 
	Role name: 'MeetingFacilitator' metaModel: metamodel.
	Role name: 'RiskAssessor' metaModel: metamodel.
	Role name: 'SubjectMatterExpert' metaModel: metamodel.
	Role name: 'TechnicalWriter' metaModel: metamodel.
	Role name: 'ProjectSponsor' metaModel: metamodel.
	Role name: 'ProcessSpecialist' metaModel: metamodel.
	Role name: 'Planner' metaModel: metamodel.
	Role name: 'ToolsSpecialist' metaModel: metamodel.
	Role name: 'QualityAssuranceEngineer' metaModel: metamodel.
	Role name: 'EconomicalAnalyst' metaModel: metamodel! !

!GenerateBigModel methodsFor: 'initialize-release' stamp: 'volosmat 4/27/2014 13:35'!
setUpRolesParent
	| person |
	person := Kind name: 'Person' metaModel: metamodel.
	ParentClass
		parentClass: person
		child: (metamodel at: 'ProjectManager').
	ParentClass 
		parentClass: person
		child: (metamodel at: 'InfrastructureEngineer').
	ParentClass
		parentClass: person
		child: (metamodel at: 'MeetingFacilitator').
	ParentClass
		parentClass: person
		child: (metamodel at: 'RiskAssessor').
	ParentClass
		parentClass: person
		child: (metamodel at: 'SubjectMatterExpert').
	ParentClass
		parentClass: person
		child: (metamodel at: 'TechnicalWriter').
	ParentClass
		parentClass: person
		child: (metamodel at: 'ProjectSponsor').
	ParentClass
		parentClass: person
		child: (metamodel at: 'ProcessSpecialist').
	ParentClass
		parentClass: person
		child: (metamodel at: 'Planner').
	ParentClass
		parentClass: person
		child: (metamodel at: 'ToolsSpecialist').
	ParentClass
		parentClass: person
		child: (metamodel at: 'QualityAssuranceEngineer').
	ParentClass
		parentClass: person
		child: (metamodel at: 'EconomicalAnalyst')! !

!GenerateBigModel methodsFor: 'generate code' stamp: 'volosmat 4/27/2014 12:34'!
testRunGenerator
	"This method only initialize and run code generator."
	CodeGenerator clearPackage: 'generatedClasses'.
	CodeGenerator setDataWithAll: (DataForGenerator UMLElements: TransformToUML transformedElements).
	
	! !

!GenerateBigModel methodsFor: 'running' stamp: 'volosmat 4/27/2014 20:45'!
testRunTransform
	TransformToUML metaModel: metamodel.
	
	self assert: (metamodel modelElements allSatisfy: [ :each | each isElementValid ])! !

Object subclass: #AbstractGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!AbstractGenerator class methodsFor: 'accessing' stamp: 'RostsilavNovk 7/23/2013 23:21'!
generate: xObject
	^self subclassResponsibility.! !

AbstractGenerator subclass: #ClassGenerator
	instanceVariableNames: ''
	classVariableNames: 'class classVariables instVariables parent'
	poolDictionaries: ''
	category: 'GMF-Generator'!

!ClassGenerator class methodsFor: 'private' stamp: 'RostislavNovak 7/24/2013 15:39'!
addAssociations
	class association
		do: [ :a | 
			(a isLeft: class)
				ifTrue: [ class addVariable: a leftVar ]
				ifFalse: [ class addVariable: a rightVar ] ]! !

!ClassGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/24/2013 00:12'!
createClass
	self class evaluatorClass evaluate: parent , ' subclass: #' , class name,'
		instanceVariableNames: ''' , instVariables,'''
		classVariableNames: ''' , classVariables,'''
		poolDictionaries: ''''
		category: ''generatedClasses'''.! !

!ClassGenerator class methodsFor: 'accessing' stamp: 'RostsilavNovk 7/24/2013 12:09'!
generate: xObject
	class := xObject.
	self setUpVariables.
	self setUpParent.
	self createClass.
	MethodGenerator generate: xObject.! !

!ClassGenerator class methodsFor: 'private' stamp: 'RostislavNovak 1/5/2014 20:01'!
getStringVariables: xCollection
	| str |
	str := ''.
	xCollection do: [ :v | str := str, ' ' , v name ].
	^ str! !

!ClassGenerator class methodsFor: 'private' stamp: 'RostislavNovak 1/5/2014 19:34'!
setUpParent
	parent := class parent isNil
		ifTrue: [ 'Object' ]
		ifFalse: [ class parent name ]! !

!ClassGenerator class methodsFor: 'private' stamp: 'RostislavNovak 7/24/2013 15:42'!
setUpVariables
	| instVars classVars |
	instVars := OrderedCollection new.
	classVars := OrderedCollection new.
	"self addAssociations."
	class variables
		do: [ :v | 
			v isInstance
				ifTrue: [ instVars add: v ]
				ifFalse: [ classVars add: v ] ].
	instVariables := self getStringVariables: instVars.
	classVariables := self getStringVariables: classVars! !

AbstractGenerator subclass: #MethodGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!MethodGenerator class methodsFor: 'private' stamp: 'volosmat 4/16/2014 23:21'!
createConstructor: xMethod
	| arguments |
	arguments := ''.
	
	xMethod arguments do: [ :each | arguments := (arguments, (Transform replaceCapitalLetter: each name),': x', each name,';
		') ].
	
	xMethod isConstructor
		ifTrue: [ ^ '
		^ super new initialize; 
            ',arguments,'
		yourself '' classified: ''instance creation'' '. ];
		ifFalse: [ ^ ' '' ' ]
	! !

!MethodGenerator class methodsFor: 'private' stamp: 'volosmat 4/16/2014 23:20'!
createMethod: xMethod Class: xClass
	| arguments isClass |
	
	arguments := self readMethodArguments: xMethod.
	isClass := ' '.
	xMethod isInstance
		ifFalse: [ isClass := ' class ' ].
	self class evaluatorClass
		evaluate:
			'' , xClass name , isClass , 'compile: ''' , xMethod name , arguments,
			(xMethod isAbstract
						ifTrue: [ '
			^ self subclassResponsibility '' ' ]
						ifFalse: [ self createConstructor: xMethod ]).
						! !

!MethodGenerator class methodsFor: 'private' stamp: 'volosmat 4/23/2014 20:09'!
createNew: xClass
	| stringToEvaluate |
	 
	xClass defaultConstructor 
		ifTrue: [ stringToEvaluate := '
	^ super new
		initialize;
		yourself' ];
		ifFalse: [ stringToEvaluate := '
	^ self shouldNotImplement' ].
	
	self class evaluatorClass evaluate:  '', xClass name, ' class compile: ''new ',stringToEvaluate,' '' classified: ''instance creation'' '! !

!MethodGenerator class methodsFor: 'accessing' stamp: 'volosmat 4/15/2014 10:36'!
generate: xObject
	"Create methods."

	xObject methods do: [ :m | self createMethod: m Class: xObject ].
	"Create additional methods."
	self createNew: xObject.
	VariableGenerator generate: xObject.! !

!MethodGenerator class methodsFor: 'private' stamp: 'RostislavNovak 1/5/2014 19:54'!
readMethodArguments: xMethod
	| arguments returnString |
	arguments := xMethod arguments.
	arguments isEmpty ifTrue: [^'' ].
	returnString := ': x' , (arguments first) name , ' '.
	arguments remove: (arguments first).
	returnString := returnString , (arguments inject: '' into: [ :str :a | str , a name , ': x' , a name , ' ' ]).
	^ returnString! !

AbstractGenerator subclass: #VariableGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

VariableGenerator class
	instanceVariableNames: 'varShakingGenerated'!

VariableGenerator class
	instanceVariableNames: 'varShakingGenerated'!

!VariableGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/24/2013 12:47'!
createCollections: xClass
	| vars |
	vars := xClass variables select:[:v | v collection notNil ].
	^(vars inject: '' into: [:str :v | str, v name, ':=', v collection, ' new', '.
		' ])! !

!VariableGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/23/2013 21:01'!
createDefaultValues
	^''.! !

!VariableGenerator class methodsFor: 'private' stamp: 'volosmat 4/23/2014 20:33'!
createEssentialSetter: xVar inverseVar: xInverseVar
	^ '
	',xVar name,' isNil & xValue notNil
		ifTrue: [',xVar name,' := xValue.
			',xVar name, ' ', xInverseVar name,': self]'''! !

!VariableGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/24/2013 12:47'!
createInitialize: xClass
	self class evaluatorClass evaluate: '' , xClass name , ' compile: ''initialize ', '
	', (self createCollections: xClass), ' 
	', self createDefaultValues, '
	', (self createNulls: xClass) , '
	 '' classified: ''initialize-release'' '.! !

!VariableGenerator class methodsFor: 'private' stamp: 'volosmat 4/23/2014 20:51'!
createInseparableSetter: xVar inverseVar: xInverseVar class: xClass
	| stringForEvaluate |
	
	stringForEvaluate :=  '
	',xVar name,' isNil & xValue notNil
		ifTrue: [',xVar name,' := xValue.
			composited := false.
			',xVar name, ' ', xInverseVar name,': self.
			composited := true ]'''.
		
	[ xClass variables detect: [ :each | each name = 'composited' ] ]
		on: Error 
		do: [ stringForEvaluate :=  '
	',xVar name,' isNil & xValue notNil
		ifTrue: [
			xValue composited
				ifFalse: [ 
					',xVar name,' := xValue.
					',xVar name, ' ', xInverseVar name,': self ]]''' ].
		
	^ stringForEvaluate! !

!VariableGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/24/2013 12:38'!
createNulls: xClass
	| vars |
	vars := xClass variables select:[:v | v collection isNil ].
	^(vars inject: '' into: [:str :v | str, v name, ':= nil.
		' ])! !

!VariableGenerator class methodsFor: 'private' stamp: 'volosmat 4/12/2014 16:56'!
createSettersGetters: xClass
	xClass variables
		do: [ :v | 
			self class evaluatorClass evaluate: '' , xClass name , ' compile: ''' , v name , '
			^' , v name , ' '' classified: ''accessing'' '.
			self class evaluatorClass evaluate: '' , xClass name , ' compile: ''' , v name ,': xVal
			' , v name , ':= xVal'' classified: ''accessing'' ' ]! !

!VariableGenerator class methodsFor: 'private' stamp: 'volosmat 4/28/2014 17:24'!
createVarShaking: xClass
	| thatClass thatVar thisVar stringForEvaluate |
	xClass association
		do: [ :as | 
			as left == xClass
				ifTrue: [ 
					thatClass := as right.
					thatVar := as rightVar.
					thisVar := as leftVar ]
				ifFalse: [ 
					thatClass := as left.
					thatVar := as leftVar.
					thisVar := as rightVar ].
				
			[varShakingGenerated at: thisVar name. 
			varShakingGenerated at: thisVar name put: ( (varShakingGenerated at: thisVar name), ' | (xValue class == ' ,thatClass name,') ' )]
				on: Error 
				do: [ varShakingGenerated at: thisVar name put: '(xValue isMemberOf: ' ,thatClass name,')' ] .
			
			thisVar collection == nil
				ifTrue: [ stringForEvaluate := '
			' , thisVar name , ' == xValue
				ifFalse: [
					' , (varShakingGenerated at: thisVar name),'
						ifTrue: [ 
							' , thisVar name,' := xValue.
							' , thisVar name , ' ' , thatVar name , ': self ] ] '' classified: ''accessing'' ' ]
				ifFalse: [ stringForEvaluate :=  '
			(' , thisVar name , ' anySatisfy: [ :v | v == xValue ] )
				ifFalse: [
					' , (varShakingGenerated at: thisVar name),'
					ifTrue: [ 
						' , thisVar name,' add: xValue.
						xValue ' , thatVar name , ': self ] ] '' classified: ''accessing'' ' ].
			"new setter when relation is essential componentOf"
			(as isEssential)
				ifTrue: [ stringForEvaluate := self createEssentialSetter: thisVar inverseVar: thatVar].
			"new setter when relation is inseparable componentOf"
			(as isInseparable)
				ifTrue: [ stringForEvaluate := self createInseparableSetter: thisVar inverseVar: thatVar class: xClass].
			self class evaluatorClass evaluate: ('' , xClass name , ' compile: ''', thisVar name, ': xValue'), stringForEvaluate  
			]! !

!VariableGenerator class methodsFor: 'accessing' stamp: 'volosmat 4/12/2014 21:32'!
generate: xObject
	varShakingGenerated := KeyedTree new.
	self createSettersGetters: xObject.
	self createInitialize: xObject.
	self createVarShaking: xObject.! !

Object subclass: #CodeGenerator
	instanceVariableNames: ''
	classVariableNames: 'data'
	poolDictionaries: ''
	category: 'GMF-Generator'!

!CodeGenerator class methodsFor: 'clear' stamp: 'volosmat 4/24/2014 23:25'!
clearPackage: packageName
	| package |
	package := PackageInfo named: packageName.
	package definedClasses
		do: [:classToRemove | classToRemove removeFromSystem]! !

!CodeGenerator class methodsFor: 'accessing' stamp: 'RostsilavNovk 7/24/2013 12:09'!
generateCode: interface
	self readData: interface.
	[ data classes notEmpty ] whileTrue: [ self readNextClass ]! !

!CodeGenerator class methodsFor: 'private' stamp: 'RostislavNovk 4/5/2013 14:16'!
readData: interface  
	data:= interface asGeneratorData.! !

!CodeGenerator class methodsFor: 'private' stamp: 'RostislavNovak 1/5/2014 19:59'!
readNextClass
	| class |
	"Take first not generated."
	class := data classes first.
	self readSelectedClass: class.! !

!CodeGenerator class methodsFor: 'private' stamp: 'RostsilavNovk 7/24/2013 11:49'!
readSelectedClass: xClass
	"If it has parent and it is not generated."
	xClass parent isNil
		ifFalse: [self readSelectedClass: xClass parent].
	"Generate class."
	ClassGenerator generate: xClass.
	data removeClass: xClass.! !

!CodeGenerator class methodsFor: 'testing' stamp: 'RostsilavNovk 7/24/2013 12:09'!
setDataWithAll: xData
	data := xData.
	[ data classes notEmpty ] whileTrue: [ self readNextClass ]! !

Object subclass: #GeneratedAll
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!GeneratedAll class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 10:32'!
new
	^ super new
		initialize;
		yourself! !

!GeneratedAll methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 10:31'!
addClass: aGeneratedClass
	"adding classes"

	classes add: aGeneratedClass.! !

!GeneratedAll methodsFor: 'accessing' stamp: 'RostsilavNovk 7/24/2013 00:54'!
classes
	^ classes copy.! !

!GeneratedAll methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 10:25'!
initialize
	"set numbers of used classes and relations to empty"

	classes := OrderedCollection new.
	^ self! !

!GeneratedAll methodsFor: 'accessing' stamp: 'RostsilavNovk 7/24/2013 00:46'!
removeClass: aGeneratedClass
	"remove  classes"

	classes :=  classes reject:[: c| c == aGeneratedClass ].! !

Object subclass: #GeneratedAssociation
	instanceVariableNames: 'left leftVar right rightVar essential inseparable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!GeneratedAssociation class methodsFor: 'instance creation' stamp: 'RostislavNovk 5/19/2013 20:54'!
newLeft: xLeft Var: xLVar RIght: xRight Var: xRVar
	^ super new
		left: xLeft;
		leftVar: xLVar;
		right: xRight;
		rightVar: xRVar;
		yourself! !

!GeneratedAssociation class methodsFor: 'instance creation' stamp: 'volosmat 4/24/2014 10:55'!
newLeft: xLeft Var: xLVar RIght: xRight Var: xRVar essential: xEssential inseparable: xInseparable
	^ super new
		left: 			xLeft;
		leftVar: 		xLVar;
		right: 			xRight;
		rightVar: 		xRVar;
		essential:		xEssential;
		inseparable: 	xInseparable;
		yourself! !

!GeneratedAssociation methodsFor: 'accessing' stamp: 'volosmat 4/15/2014 18:55'!
essential: xEssential
	essential := xEssential ! !

!GeneratedAssociation methodsFor: 'accessing' stamp: 'volosmat 4/23/2014 12:34'!
inseparable: xInseparable
	inseparable := xInseparable! !

!GeneratedAssociation methodsFor: 'accessing' stamp: 'volosmat 4/15/2014 18:56'!
isEssential
	^ essential ifNil: [ essential := false ]! !

!GeneratedAssociation methodsFor: 'accessing' stamp: 'volosmat 4/23/2014 12:35'!
isInseparable
	^ inseparable ifNil: [ inseparable := false ]! !

!GeneratedAssociation methodsFor: 'testing' stamp: 'RostsilavNovk 7/24/2013 13:01'!
isLeft: xClass
	^left == xClass! !

!GeneratedAssociation methodsFor: 'testing' stamp: 'RostsilavNovk 7/24/2013 13:01'!
isRight: xClass
	^right == xClass! !

!GeneratedAssociation methodsFor: 'accessing' stamp: 'RostislavNovk 5/19/2013 20:50'!
left
 ^left! !

!GeneratedAssociation methodsFor: 'private' stamp: 'volosmat 4/24/2014 11:05'!
left: xLeft
	left := xLeft.
	xLeft association: self! !

!GeneratedAssociation methodsFor: 'accessing' stamp: 'RostislavNovk 5/19/2013 20:51'!
leftVar
 ^leftVar! !

!GeneratedAssociation methodsFor: 'private' stamp: 'RostislavNovk 5/19/2013 20:50'!
leftVar: xLeft
	leftVar := xLeft! !

!GeneratedAssociation methodsFor: 'accessing' stamp: 'RostislavNovk 5/19/2013 20:50'!
right
^right! !

!GeneratedAssociation methodsFor: 'private' stamp: 'volosmat 4/24/2014 11:05'!
right: xRight
	right := xRight.
	xRight association: self! !

!GeneratedAssociation methodsFor: 'accessing' stamp: 'RostislavNovk 5/19/2013 20:51'!
rightVar
^rightVar! !

!GeneratedAssociation methodsFor: 'private' stamp: 'RostislavNovk 5/19/2013 20:50'!
rightVar: xRight
	rightVar := xRight! !

Object subclass: #GeneratedClass
	instanceVariableNames: 'name comment variables methods superClass generated association defaultConstructor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!GeneratedClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:43'!
newName: xName
	^ super new
		initialize;
		name: xName;
		yourself! !

!GeneratedClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:44'!
newName: xName Comment: xComment
	^ super new
		initialize;
		name: xName;
		comment: xComment;
		yourself! !

!GeneratedClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:44'!
newName: xName Comment: xComment Code: xCode
	^ super new
		initialize;
		name: xName;
		comment: xComment;
		code: xCode;
		yourself! !

!GeneratedClass class methodsFor: 'instance creation' stamp: 'volosmat 4/23/2014 20:05'!
newName: xName defaultConstructor: xDefaultConstructor
	^ super new
		initialize;
		name: xName;
		defaultConstructor: xDefaultConstructor;
		yourself! !

!GeneratedClass methodsFor: 'accessing' stamp: 'JiriMertin 4/1/2013 19:27'!
addMethod: aGeneratedEOCMethod
	"add to sortedcollection"

	methods add: aGeneratedEOCMethod! !

!GeneratedClass methodsFor: 'accessing' stamp: 'volosmat 4/12/2014 16:33'!
addVariable: aGeneratedEOCVariable
	"add to sortedcollection"
	[ variables detect: [ :each | each name = aGeneratedEOCVariable name ] ]
		on: Error
		do: [ variables add: aGeneratedEOCVariable ]! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 5/19/2013 20:59'!
association
	^association copy.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 5/19/2013 21:42'!
association: xAs
	association add: xAs.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
comment
	^comment.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:50'!
comment: xComment
	comment:= xComment.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'volosmat 4/23/2014 20:06'!
defaultConstructor
	^ defaultConstructor! !

!GeneratedClass methodsFor: 'accessing' stamp: 'volosmat 4/23/2014 20:06'!
defaultConstructor: anObject
	defaultConstructor := anObject! !

!GeneratedClass methodsFor: 'initialize-release' stamp: 'volosmat 4/23/2014 20:04'!
initialize
	variables			:= OrderedCollection new.
	methods			:= OrderedCollection new.
	association			:= OrderedCollection  new.
	comment			:=''.
	superClass			:=nil.
	generated 			:= false.
	defaultConstructor := true.
	! !

!GeneratedClass methodsFor: 'testing' stamp: 'RostislavNovk 4/8/2013 00:25'!
isGenerated
	^generated! !

!GeneratedClass methodsFor: 'testing' stamp: 'RostislavNovk 4/5/2013 11:07'!
isSubClass
	[ superClass isNil ]
		ifTrue: [ ^ false ]
		ifFalse: [ ^ true ]! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
methods
	^methods copy.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
name
	^name.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:50'!
name: xName
	name:= xName.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
parent
	^superClass.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:50'!
parent: xGeneratedClass
	superClass:= xGeneratedClass .! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:49'!
variables
	^variables copy.! !

!GeneratedClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/8/2013 00:26'!
wasGenerated
	generated := true.! !

Object subclass: #GeneratedElementOfClass
	instanceVariableNames: 'name instance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

GeneratedElementOfClass subclass: #GeneratedEOCMethod
	instanceVariableNames: 'code arguments abstract constructor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!GeneratedEOCMethod class methodsFor: 'instance creation' stamp: 'volosmat 4/24/2014 10:35'!
newName: xName
	^ (super new initialize)
		name: 		xName;
		yourself! !

!GeneratedEOCMethod class methodsFor: 'instance creation' stamp: 'volosmat 4/24/2014 10:36'!
newName: xName Abstract: xAbstract
	^ (super new initialize)
		abstract: 		xAbstract;
		name: 		xName;
		yourself! !

!GeneratedEOCMethod class methodsFor: 'instance creation' stamp: 'volosmat 4/24/2014 10:36'!
newName: xName Instance: xInstance Abstract: xAbstract
	^ (super new initialize)
		abstract: 		xAbstract;
		name: 			xName;
		instance:		xInstance;
		yourself! !

!GeneratedEOCMethod class methodsFor: 'instance creation' stamp: 'volosmat 4/24/2014 10:36'!
newName: xName Instance: xInstance Abstract: xAbstract Constructor: xConstructor
	^ (super new initialize)
		abstract: 		xAbstract;
		constructor: 	xConstructor;
		name: 			xName;
		instance:		xInstance;
		yourself! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 18:56'!
abstract: xAbstract
	abstract := xAbstract.! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:28'!
addArgument: xGeneratedEOCVariable
	arguments add: xGeneratedEOCVariable! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:51'!
arguments
	^ arguments copy! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:51'!
code
	^ code! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:47'!
code: xCode 
	code := xCode.! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'volosmat 4/15/2014 09:17'!
constructor: anObject
	constructor := anObject! !

!GeneratedEOCMethod methodsFor: 'initialize-release' stamp: 'volosmat 4/16/2014 23:11'!
initialize
	super initialize.
	abstract := false.
	constructor  := false.
	arguments:= OrderedCollection new.! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 18:55'!
isAbstract
	^abstract! !

!GeneratedEOCMethod methodsFor: 'accessing' stamp: 'volosmat 4/15/2014 09:40'!
isConstructor
	^ constructor! !

GeneratedElementOfClass subclass: #GeneratedEOCVariable
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Generator'!

!GeneratedEOCVariable methodsFor: 'accessing' stamp: 'RostislavNovk 5/10/2013 20:01'!
collection
	^collection! !

!GeneratedEOCVariable methodsFor: 'accessing' stamp: 'RostislavNovk 5/10/2013 20:01'!
collection: xCollection
	collection := xCollection! !

!GeneratedElementOfClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 4/5/2013 13:46'!
newName: xName
	^ super new
		initialize;
		name: xName;
		yourself! !

!GeneratedElementOfClass class methodsFor: 'instance creation' stamp: 'volosmat 4/15/2014 10:46'!
newName: xName Instance: xInstance
	^ super new
		initialize;
		name: xName;
		instance: xInstance;
		yourself! !

!GeneratedElementOfClass methodsFor: 'initialize-release' stamp: 'RostislavNovk 4/5/2013 18:01'!
initialize
	instance := true
! !

!GeneratedElementOfClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:51'!
instance: xInstance
	instance:=xInstance.
! !

!GeneratedElementOfClass methodsFor: 'accessing' stamp: 'RostislavNovak 1/5/2014 19:39'!
isClass
	"returns opposite of isInstantce"

	^ instance not.! !

!GeneratedElementOfClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 17:59'!
isInstance
	^ instance! !

!GeneratedElementOfClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:52'!
name
	^ name! !

!GeneratedElementOfClass methodsFor: 'accessing' stamp: 'RostislavNovk 4/5/2013 13:51'!
name: xName
	name := xName.
! !
